package cn.iocoder.yudao.module.member.service.rechargeamount;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.member.controller.admin.rechargeamount.vo.RechargeAmountPageReqVO;
import cn.iocoder.yudao.module.member.controller.admin.rechargeamount.vo.RechargeAmountSaveReqVO;
import cn.iocoder.yudao.module.member.dal.dataobject.rechargeamount.RechargeAmountDO;

import javax.validation.Valid;
import java.math.BigDecimal;
import java.util.List;

/**
 * 充值金额配置 Service 接口
 *
 * @author 开发账号
 */
public interface RechargeAmountService {

    /**
     * 创建充值金额配置
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Long createRechargeAmount(@Valid RechargeAmountSaveReqVO createReqVO);

    /**
     * 更新充值金额配置
     *
     * @param updateReqVO 更新信息
     */
    void updateRechargeAmount(@Valid RechargeAmountSaveReqVO updateReqVO);

    /**
     * 删除充值金额配置
     *
     * @param id 编号
     */
    void deleteRechargeAmount(Long id);

    /**
     * 获得充值金额配置
     *
     * @param id 编号
     * @return 充值金额配置
     */
    RechargeAmountDO getRechargeAmount(Long id);

    /**
     * 获得充值金额配置分页
     *
     * @param pageReqVO 分页查询
     * @return 充值金额配置分页
     */
    PageResult<RechargeAmountDO> getRechargeAmountPage(RechargeAmountPageReqVO pageReqVO);

    List<RechargeAmountDO> getAmount();

    RechargeAmountDO getRecharge(BigDecimal money);
}